<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: PidThrust.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_pid_thrust_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">PidThrust.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_pid_thrust_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef PIDTHRUST_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define PIDTHRUST_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_control_law_8h.html">ControlLaw.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>LayoutPosition;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;}</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span>PidThrust_impl;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>filter {</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classflair_1_1filter_1_1_pid_thrust.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1filter_1_1_pid_thrust.html">PidThrust</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1filter_1_1_control_law.html">ControlLaw</a> {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;  <span class="keyword">friend</span> class ::PidThrust_impl;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#ab46191511449bc44699102a239eb82f6">PidThrust</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position, std::string name);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a0332ced449a5257a484e484379921445">~PidThrust</a>();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a4987d6892e567cce5af9b22dcf065542">Reset</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#ad82440a1c4d9b0409c8549f900991223">ResetI</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a240df5714f7ffe4fd2cb7765a21389ee">SetOffset</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a5e856db9c472b9ca3b6b69eb54ffa18e">SetDefaultOffset</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a746b8f8afd363524b6b84a1fc8d11da2">GetOffset</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a35d8c2f7a19faaae43b3a6d2d3cc211a">GetIntegral</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#ac556b3702ad3352fdfad1bde19f16af0">OffsetStepUp</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#ac3810b92073bc3e5062a387e089b2295">OffsetStepDown</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#afdbec017ebadc52cef7e901ecd92d959">SetValues</a>(<span class="keywordtype">float</span> p, <span class="keywordtype">float</span> d);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1filter_1_1_pid_thrust.html#a8b77f7720b1406f48baa3c43cf87765a">UseDefaultPlot</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;  <span class="keywordtype">void</span> UpdateFrom(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;  PidThrust_impl *pimpl_;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;};</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;} <span class="comment">// end namespace filter</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="preprocessor">#endif // PIDTHRUST_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_control_law_html"><div class="ttname"><a href="classflair_1_1filter_1_1_control_law.html">flair::filter::ControlLaw</a></div><div class="ttdoc">Base class for control law input must be created by reimplemented class. output is created by this cl...</div><div class="ttdef"><b>Definition:</b> ControlLaw.h:36</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a240df5714f7ffe4fd2cb7765a21389ee"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a240df5714f7ffe4fd2cb7765a21389ee">flair::filter::PidThrust::SetOffset</a></div><div class="ttdeci">void SetOffset(float value)</div><div class="ttdoc">Set offset to a specified value. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html">flair::filter::PidThrust</a></div><div class="ttdoc">Class defining a Pid for Thrust. This Pid as an extra offset for compensating gravity. </div><div class="ttdef"><b>Definition:</b> PidThrust.h:33</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_ac556b3702ad3352fdfad1bde19f16af0"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#ac556b3702ad3352fdfad1bde19f16af0">flair::filter::PidThrust::OffsetStepUp</a></div><div class="ttdeci">bool OffsetStepUp(void)</div><div class="ttdoc">Step up the offset according to specified value in ground station. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a0332ced449a5257a484e484379921445"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a0332ced449a5257a484e484379921445">flair::filter::PidThrust::~PidThrust</a></div><div class="ttdeci">~PidThrust()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="_control_law_8h_html"><div class="ttname"><a href="_control_law_8h.html">ControlLaw.h</a></div><div class="ttdoc">Base class for control law. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_afdbec017ebadc52cef7e901ecd92d959"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#afdbec017ebadc52cef7e901ecd92d959">flair::filter::PidThrust::SetValues</a></div><div class="ttdeci">void SetValues(float p, float d)</div><div class="ttdoc">Set input values. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_ad82440a1c4d9b0409c8549f900991223"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#ad82440a1c4d9b0409c8549f900991223">flair::filter::PidThrust::ResetI</a></div><div class="ttdeci">void ResetI(void)</div><div class="ttdoc">Reset integral to 0. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_ac3810b92073bc3e5062a387e089b2295"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#ac3810b92073bc3e5062a387e089b2295">flair::filter::PidThrust::OffsetStepDown</a></div><div class="ttdeci">bool OffsetStepDown(void)</div><div class="ttdoc">Step down the offset according to specified value in ground station. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a746b8f8afd363524b6b84a1fc8d11da2"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a746b8f8afd363524b6b84a1fc8d11da2">flair::filter::PidThrust::GetOffset</a></div><div class="ttdeci">float GetOffset(void) const </div><div class="ttdoc">Get offset. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_ab46191511449bc44699102a239eb82f6"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#ab46191511449bc44699102a239eb82f6">flair::filter::PidThrust::PidThrust</a></div><div class="ttdeci">PidThrust(const gui::LayoutPosition *position, std::string name)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a35d8c2f7a19faaae43b3a6d2d3cc211a"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a35d8c2f7a19faaae43b3a6d2d3cc211a">flair::filter::PidThrust::GetIntegral</a></div><div class="ttdeci">float GetIntegral(void) const </div><div class="ttdoc">Get intergral part. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a4987d6892e567cce5af9b22dcf065542"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a4987d6892e567cce5af9b22dcf065542">flair::filter::PidThrust::Reset</a></div><div class="ttdeci">void Reset(void)</div><div class="ttdoc">Reset the control law equivalent to: ResetI(); SetDefaultOffset(); SetValues(0,0);. </div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a5e856db9c472b9ca3b6b69eb54ffa18e"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a5e856db9c472b9ca3b6b69eb54ffa18e">flair::filter::PidThrust::SetDefaultOffset</a></div><div class="ttdeci">void SetDefaultOffset(void)</div><div class="ttdoc">Set offset to specified value in ground station. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_layout_position_html"><div class="ttname"><a href="classflair_1_1gui_1_1_layout_position.html">flair::gui::LayoutPosition</a></div><div class="ttdoc">Class to define a position in a layout on the ground station. </div><div class="ttdef"><b>Definition:</b> LayoutPosition.h:28</div></div>
<div class="ttc" id="classflair_1_1filter_1_1_pid_thrust_html_a8b77f7720b1406f48baa3c43cf87765a"><div class="ttname"><a href="classflair_1_1filter_1_1_pid_thrust.html#a8b77f7720b1406f48baa3c43cf87765a">flair::filter::PidThrust::UseDefaultPlot</a></div><div class="ttdeci">void UseDefaultPlot(const gui::LayoutPosition *position)</div><div class="ttdoc">Use default plot. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_c640b400eb634d478af9606dd6c9f1e6.html">FlairFilter</a></li><li class="navelem"><a class="el" href="dir_9f4b49da50e680b0f2ceec11232e4cfd.html">src</a></li><li class="navelem"><a class="el" href="_pid_thrust_8h.html">PidThrust.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
